/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package tictactoecodingame;

import static java.lang.Math.max;
import static java.lang.Math.min;
import java.util.ArrayList;

/**
 *
 * @author Alain
 */
public class AlgoRechercheMinMax extends AlgoRecherche {
    
    Joueur humain;
    public AlgoRechercheMinMax(Joueur _joueur){
        humain = _joueur;
    }
    
    String[][] grille = {{"","",""},{"","",""},{"","",""}};
    double[] scores = {1,-1,0};

    @Override
    public Coup meilleurCoup(Plateau _plateau, Joueur _joueur, boolean ponder){
      double inf = Double.POSITIVE_INFINITY;
      double bestScore = -1 * inf;
      CoupTicTacToe meilleur_coup = null ;
      ArrayList<Coup> coups = _plateau.getListeCoups(_joueur);
      
      for (int i = 0; i < coups.size(); i++){
        _plateau.joueCoup(coups.get(i));    
        double score = minimax(_plateau,humain,0,false); //False car l'ordi a déjà placé son premier coup
        Coup coup_provisoire = coups.get(i);
        _plateau.annuleDernierCoup();
        if (score > bestScore){
            bestScore = score;
            meilleur_coup = (CoupTicTacToe)coup_provisoire;
                }
            } 
      return meilleur_coup;
      // changer le tour du joueur 
    }
    
    public double minimax(Plateau _plateau,Joueur _joueur,int profondeur,boolean isMaximizing){
        
        if (_plateau.partieTerminee()){
            if(_plateau.partieNulle()){
                return 0;               
            }
            else{
                Joueur gagnant = _plateau.vainqueur(); //Il faudrait connaitre le vainqueur
                int resultat = gagnant.getIdJoueur();
                return scores[resultat];
            }
        }      
        if (isMaximizing) { //ordi qui joue
      double inf = Double.POSITIVE_INFINITY;
      double bestScore = -1 * inf;
      ArrayList<Coup> coups = _plateau.getListeCoups(_joueur);
      for (int i = 0; i < coups.size(); i++){
        _plateau.joueCoup(coups.get(i));
            double score = minimax(_plateau,humain,profondeur + 1,false);
            _plateau.annuleDernierCoup();
            bestScore = max(score,bestScore);
        }
      return bestScore;
     }
       else { // Humain ou autre ordi qui joue
            double inf = Double.POSITIVE_INFINITY;
            double bestScore = inf;
            ArrayList<Coup> coups = _plateau.getListeCoups(humain);
            for (int i = 0; i < coups.size(); i++){
                _plateau.joueCoup(coups.get(i)); // problème : Il faut que ce soit l'autre joueur qui joue ici
                double score = minimax(_plateau,_joueur,profondeur + 1,true);
                _plateau.annuleDernierCoup();
                bestScore = min(score,bestScore);
        }
            
            return bestScore;
        }
    }
}
    

